diff --git a/roms/ipxe/src/hci/commands/nslookup_cmd.c b/roms/ipxe/src/hci/commands/nslookup_cmd.c
new file mode 100644
index 0000000000000000000000000000000000000000..265afdc3d297f707ae0586fc8b6cd20915de323f
--- /dev/null
+++ b/roms/ipxe/src/hci/commands/nslookup_cmd.c
@@ -0,0 +1,79 @@
+/*
+ * Copyright (C) 2012 Patrick Plenefisch <phplenefisch@wpi.edu>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <stdio.h>
+#include <getopt.h>
+#include <ipxe/command.h>
+#include <ipxe/parseopt.h>
+#include <usr/nslookup.h>
+
+/** @file
+ *
+ * nslookup command
+ *
+ */
+
+/** "nslookup" options */
+struct nslookup_options {};
+
+/** "nslookup" option list */
+static struct option_descriptor nslookup_opts[] = {};
+
+/** "nslookup" command descriptor */
+static struct command_descriptor nslookup_cmd =
+	COMMAND_DESC ( struct nslookup_options, nslookup_opts, 2, 2,
+		       "<setting> <name>" );
+
+/**
+ * The "nslookup" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int nslookup_exec ( int argc, char **argv ) {
+	struct nslookup_options opts;
+	const char *name;
+	const char *setting_name;
+	int rc;
+
+	/* Parse options */
+	if ( ( rc = parse_options ( argc, argv, &nslookup_cmd, &opts ) ) != 0 )
+		return rc;
+
+	/* Parse setting name */
+	setting_name = argv[optind];
+
+	/* Parse name to be resolved */
+	name = argv[ optind + 1 ];
+
+	/* Look up name */
+	if ( ( rc = nslookup ( name, setting_name ) ) != 0 )
+		return rc;
+
+	return 0;
+}
+
+/** The "nslookup" command */
+struct command nslookup_command __command = {
+	.name = "nslookup",
+	.exec = nslookup_exec,
+};
diff --git a/roms/ipxe/src/hci/commands/nvo_cmd.c b/roms/ipxe/src/hci/commands/nvo_cmd.c
index a7e0f4a039474852501fb8d56bf0..f255bbf5742bfc2d0b23b21b2194 100644
--- a/roms/ipxe/src/hci/commands/nvo_cmd.c
+++ b/roms/ipxe/src/hci/commands/nvo_cmd.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 #include <stdint.h>
@@ -108,7 +109,8 @@ static struct command_descriptor clear_read_cmd =
  */
 static int set_core_exec ( int argc, char **argv,
 			   struct command_descriptor *cmd,
-			   int ( * get_value ) ( char **args, char **value ) ) {
+			   int ( * get_value ) ( const char *name,
+						 char **args, char **value ) ) {
 	struct set_core_options opts;
 	const char *name;
 	char *value;
@@ -122,11 +124,12 @@ static int set_core_exec ( int argc, char **argv,
 	name = argv[optind];
 
 	/* Parse setting value */
-	if ( ( rc = get_value ( &argv[ optind + 1 ], &value ) ) != 0 )
+	if ( ( rc = get_value ( name, &argv[ optind + 1 ], &value ) ) != 0 )
 		goto err_get_value;
 
 	/* Determine total length of command line */
-	if ( ( rc = storef_named_setting ( name, value ) ) != 0 ) {
+	if ( ( rc = storef_named_setting ( name, &setting_type_string,
+					   value ) ) != 0 ) {
 		printf ( "Could not %s \"%s\": %s\n",
 			 argv[0], name, strerror ( rc ) );
 		goto err_store;
@@ -145,11 +148,12 @@ static int set_core_exec ( int argc, char **argv,
 /**
  * Get setting value for "set" command
  *
+ * @v name		Setting name
  * @v args		Remaining arguments
  * @ret value		Setting value
  * @ret rc		Return status code
  */
-static int set_value ( char **args, char **value ) {
+static int set_value ( const char *name __unused, char **args, char **value ) {
 
 	*value = concat_args ( args );
 	if ( ! *value )
@@ -172,11 +176,13 @@ static int set_exec ( int argc, char **argv ) {
 /**
  * Get setting value for "clear" command
  *
+ * @v name		Setting name
  * @v args		Remaining arguments
  * @ret value		Setting value
  * @ret rc		Return status code
  */
-static int clear_value ( char **args __unused, char **value ) {
+static int clear_value ( const char *name __unused, char **args __unused,
+			 char **value ) {
 
 	*value = NULL;
 	return 0;
@@ -196,16 +202,30 @@ static int clear_exec ( int argc, char **argv ) {
 /**
  * Get setting value for "read" command
  *
+ * @v name		Setting name
+ * @v args		Remaining arguments
  * @ret value		Setting value
  * @ret rc		Return status code
  */
-static int read_value ( char **args __unused, char **value ) {
+static int read_value ( const char *name, char **args __unused, char **value ) {
+	char *existing;
+	int rc;
 
-	*value = readline ( NULL );
-	if ( ! *value )
-		return -ENOMEM;
+	/* Read existing value */
+	if ( ( rc = fetchf_named_setting_copy ( name, &existing ) ) < 0 )
+		goto err_existing;
 
-	return 0;
+	/* Read new value */
+	if ( ( rc = readline_history ( NULL, existing, NULL, value ) ) != 0 )
+		goto err_new;
+
+	/* Success */
+	rc = 0;
+
+ err_new:
+	free ( existing );
+ err_existing:
+	return rc;
 }
 
 /**
diff --git a/roms/ipxe/src/hci/commands/route_cmd.c b/roms/ipxe/src/hci/commands/route_cmd.c
index f839d53f438e566cabf525a5b908..3b51f06b0e3b0e43220bb784e064 100644
--- a/roms/ipxe/src/hci/commands/route_cmd.c
+++ b/roms/ipxe/src/hci/commands/route_cmd.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/hci/commands/sanboot_cmd.c b/roms/ipxe/src/hci/commands/sanboot_cmd.c
index 198a7322d78d21c2c83aadbc5597..14055a8c41d00f675935def8b3cb 100644
--- a/roms/ipxe/src/hci/commands/sanboot_cmd.c
+++ b/roms/ipxe/src/hci/commands/sanboot_cmd.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 #include <stdio.h>
@@ -23,6 +24,7 @@
 #include <ipxe/command.h>
 #include <ipxe/parseopt.h>
 #include <ipxe/uri.h>
+#include <ipxe/sanboot.h>
 #include <usr/autoboot.h>
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -34,47 +36,92 @@ FILE_LICENCE ( GPL2_OR_LATER );
  */
 
 /** "sanboot" options */
-struct sanboot_options {};
+struct sanboot_options {
+	/** Drive number */
+	unsigned int drive;
+	/** Do not describe SAN device */
+	int no_describe;
+	/** Keep SAN device */
+	int keep;
+};
 
 /** "sanboot" option list */
-static struct option_descriptor sanboot_opts[] = {};
+static struct option_descriptor sanboot_opts[] = {
+	OPTION_DESC ( "drive", 'd', required_argument,
+		      struct sanboot_options, drive, parse_integer ),
+	OPTION_DESC ( "no-describe", 'n', no_argument,
+		      struct sanboot_options, no_describe, parse_flag ),
+	OPTION_DESC ( "keep", 'k', no_argument,
+		      struct sanboot_options, keep, parse_flag ),
+};
+
+/** "sanhook" command descriptor */
+static struct command_descriptor sanhook_cmd =
+	COMMAND_DESC ( struct sanboot_options, sanboot_opts, 1, 1,
+		       "[--drive <drive>] [--no-describe] <root-path>" );
 
 /** "sanboot" command descriptor */
 static struct command_descriptor sanboot_cmd =
-	COMMAND_DESC ( struct sanboot_options, sanboot_opts, 1, 1,
-		       "<root-path>" );
+	COMMAND_DESC ( struct sanboot_options, sanboot_opts, 0, 1,
+		       "[--drive <drive>] [--no-describe] [--keep] "
+		       "[<root-path>]" );
+
+/** "sanunhook" command descriptor */
+static struct command_descriptor sanunhook_cmd =
+	COMMAND_DESC ( struct sanboot_options, sanboot_opts, 0, 0,
+		       "[--drive <drive>]" );
 
 /**
- * The "sanboot" command
+ * The "sanboot", "sanhook" and "sanunhook" commands
  *
  * @v argc		Argument count
  * @v argv		Argument list
+ * @v default_flags	Default set of flags for uriboot()
+ * @v no_root_path_flags Additional flags to apply if no root path is present
  * @ret rc		Return status code
  */
-static int sanboot_exec ( int argc, char **argv ) {
+static int sanboot_core_exec ( int argc, char **argv,
+			       struct command_descriptor *cmd,
+			       int default_flags, int no_root_path_flags ) {
 	struct sanboot_options opts;
 	const char *root_path;
 	struct uri *uri;
+	int flags;
 	int rc;
 
+	/* Initialise options */
+	memset ( &opts, 0, sizeof ( opts ) );
+	opts.drive = san_default_drive();
+
 	/* Parse options */
-	if ( ( rc = parse_options ( argc, argv, &sanboot_cmd, &opts ) ) != 0 )
+	if ( ( rc = reparse_options ( argc, argv, cmd, &opts ) ) != 0 )
 		goto err_parse_options;
 
-	/* Parse root path */
-	root_path = argv[optind];
-	uri = parse_uri ( root_path );
-	if ( ! uri ) {
-		rc = -ENOMEM;
-		goto err_parse_uri;
+	/* Parse root path, if present */
+	if ( argc > optind ) {
+		root_path = argv[optind];
+		uri = parse_uri ( root_path );
+		if ( ! uri ) {
+			rc = -ENOMEM;
+			goto err_parse_uri;
+		}
+	} else {
+		root_path = NULL;
+		uri = NULL;
 	}
 
+	/* Construct flags */
+	flags = default_flags;
+	if ( opts.no_describe )
+		flags |= URIBOOT_NO_SAN_DESCRIBE;
+	if ( opts.keep )
+		flags |= URIBOOT_NO_SAN_UNHOOK;
+	if ( ! root_path )
+		flags |= no_root_path_flags;
+
 	/* Boot from root path */
-	if ( ( rc = uriboot ( NULL, uri ) ) != 0 ) {
-		printf ( "Could not boot from %s: %s\n",
-			 root_path, strerror ( rc ) );
+	if ( ( rc = uriboot ( NULL, uri, opts.drive, flags ) ) != 0 )
 		goto err_uriboot;
-	}
 
  err_uriboot:
 	uri_put ( uri );
@@ -83,8 +130,56 @@ static int sanboot_exec ( int argc, char **argv ) {
 	return rc;
 }
 
+/**
+ * The "sanhook" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int sanhook_exec ( int argc, char **argv ) {
+	return sanboot_core_exec ( argc, argv, &sanhook_cmd,
+				   ( URIBOOT_NO_SAN_BOOT |
+				     URIBOOT_NO_SAN_UNHOOK ), 0 );
+}
+
+/**
+ * The "sanboot" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int sanboot_exec ( int argc, char **argv ) {
+	return sanboot_core_exec ( argc, argv, &sanboot_cmd,
+				   0, URIBOOT_NO_SAN_UNHOOK );
+}
+
+/**
+ * The "sanunhook" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int sanunhook_exec ( int argc, char **argv ) {
+	return sanboot_core_exec ( argc, argv, &sanunhook_cmd,
+				   ( URIBOOT_NO_SAN_DESCRIBE |
+				     URIBOOT_NO_SAN_BOOT ), 0 );
+}
+
 /** SAN commands */
-struct command sanboot_command __command = {
-	.name = "sanboot",
-	.exec = sanboot_exec,
+struct command sanboot_commands[] __command = {
+	{
+		.name = "sanhook",
+		.exec = sanhook_exec,
+	},
+	{
+		.name = "sanboot",
+		.exec = sanboot_exec,
+	},
+	{
+		.name = "sanunhook",
+		.exec = sanunhook_exec,
+	},
 };
diff --git a/roms/ipxe/src/hci/commands/sync_cmd.c b/roms/ipxe/src/hci/commands/sync_cmd.c
new file mode 100644
index 0000000000000000000000000000000000000000..221e87395278885fc1ec9acf0fcb1e5665799d1c
--- /dev/null
+++ b/roms/ipxe/src/hci/commands/sync_cmd.c
@@ -0,0 +1,83 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <string.h>
+#include <stdio.h>
+#include <getopt.h>
+#include <ipxe/command.h>
+#include <ipxe/parseopt.h>
+#include <ipxe/timer.h>
+#include <ipxe/pending.h>
+
+/** @file
+ *
+ * "sync" command
+ *
+ */
+
+/** "sync" options */
+struct sync_options {
+	/** Timeout */
+	unsigned int timeout;
+};
+
+/** "sync" option list */
+static struct option_descriptor sync_opts[] = {
+	OPTION_DESC ( "timeout", 't', required_argument,
+		      struct sync_options, timeout, parse_integer ),
+};
+
+/** "sync" command descriptor */
+static struct command_descriptor sync_cmd =
+	COMMAND_DESC ( struct sync_options, sync_opts, 0, 0,
+		       "[--timeout <timeout>]" );
+
+/**
+ * "sync" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int sync_exec ( int argc, char **argv ) {
+	struct sync_options opts;
+	unsigned long timeout;
+	int rc;
+
+	/* Parse options */
+	if ( ( rc = parse_options ( argc, argv, &sync_cmd, &opts ) ) != 0 )
+		return rc;
+
+	/* Wait for pending operations to complete */
+	timeout = ( ( opts.timeout * TICKS_PER_SEC ) / 1000 );
+	if ( ( rc = pending_wait ( timeout ) ) != 0 ) {
+		printf ( "Operations did not complete: %s\n", strerror ( rc ) );
+		return rc;
+	}
+
+	return 0;
+}
+
+/** Sync commands */
+struct command sync_command __command = {
+	.name = "sync",
+	.exec = sync_exec,
+};
diff --git a/roms/ipxe/src/hci/commands/time_cmd.c b/roms/ipxe/src/hci/commands/time_cmd.c
index 1dd175783c05f52309209c05785f..d1dd49cafe4d9aa84f91f56652c2 100644
--- a/roms/ipxe/src/hci/commands/time_cmd.c
+++ b/roms/ipxe/src/hci/commands/time_cmd.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  *
  * March-19-2009 @ 02:44: Added sleep command.
  * Shao Miller <shao.miller@yrdsb.edu.on.ca>.
@@ -27,7 +28,6 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #include <unistd.h>
 #include <ipxe/command.h>
 #include <ipxe/parseopt.h>
-#include <ipxe/nap.h>
 #include <ipxe/timer.h>
 
 /** @file
@@ -57,7 +57,8 @@ static struct command_descriptor time_cmd =
 static int time_exec ( int argc, char **argv ) {
 	struct time_options opts;
 	unsigned long start;
-	int secs;
+	unsigned long elapsed;
+	int decisecs;
 	int rc;
 
 	/* Parse options */
@@ -66,9 +67,11 @@ static int time_exec ( int argc, char **argv ) {
 
 	start = currticks();
 	rc = execv ( argv[1], argv + 1 );
-	secs = (currticks() - start) / ticks_per_sec();
+	elapsed = ( currticks() - start );
+	decisecs = ( 10 * elapsed / ticks_per_sec() );
 
-	printf ( "%s: %ds\n", argv[0], secs );
+	printf ( "%s: %d.%ds\n", argv[0],
+		 ( decisecs / 10 ), ( decisecs % 10 ) );
 
 	return rc;
 }
@@ -78,42 +81,3 @@ struct command time_command __command = {
 	.name = "time",
 	.exec = time_exec,
 };
-
-/** "sleep" options */
-struct sleep_options {};
-
-/** "sleep" option list */
-static struct option_descriptor sleep_opts[] = {};
-
-/** "sleep" command descriptor */
-static struct command_descriptor sleep_cmd =
-	COMMAND_DESC ( struct sleep_options, sleep_opts, 1, 1, "<seconds>" );
-
-/**
- * "sleep" command
- *
- * @v argc		Argument count
- * @v argv		Argument list
- * @ret rc		Return status code
- */
-static int sleep_exec ( int argc, char **argv ) {
-	struct sleep_options opts;
-	unsigned long start, delay;
-	int rc;
-
-	/* Parse options */
-	if ( ( rc = parse_options ( argc, argv, &sleep_cmd, &opts ) ) != 0 )
-		return rc;
-
-	start = currticks();
-	delay = strtoul ( argv[1], NULL, 0 ) * ticks_per_sec();
-	while ( ( currticks() - start ) <= delay )
-		cpu_nap();
-	return 0;
-}
-
-/** "sleep" command */
-struct command sleep_command __command = {
-	.name = "sleep",
-	.exec = sleep_exec,
-};
diff --git a/roms/ipxe/src/hci/commands/vlan_cmd.c b/roms/ipxe/src/hci/commands/vlan_cmd.c
index 28638ae6a3b7c747ef7918c6dc74..822e5dcf3cb527dc1968dc350e03 100644
--- a/roms/ipxe/src/hci/commands/vlan_cmd.c
+++ b/roms/ipxe/src/hci/commands/vlan_cmd.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/hci/editstring.c b/roms/ipxe/src/hci/editstring.c
index 996528ff563a07d057c03b66dfbd..8c56d2337b524eb4570405699fee 100644
--- a/roms/ipxe/src/hci/editstring.c
+++ b/roms/ipxe/src/hci/editstring.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -36,6 +37,7 @@ static void insert_character ( struct edit_string *string,
                                unsigned int character ) __nonnull;
 static void delete_character ( struct edit_string *string ) __nonnull;
 static void backspace ( struct edit_string *string ) __nonnull;
+static void kill_sol ( struct edit_string *string ) __nonnull;
 static void kill_eol ( struct edit_string *string ) __nonnull;
 
 /**
@@ -108,6 +110,17 @@ static void backspace ( struct edit_string *string ) {
 	}
 }
 
+/**
+ * Delete to start of line
+ *
+ * @v string           Editable string
+ */
+static void kill_sol ( struct edit_string *string ) {
+	size_t old_cursor = string->cursor;
+	string->cursor = 0;
+	insert_delete ( string, old_cursor, NULL );
+}
+
 /**
  * Delete to end of line
  *
@@ -168,6 +181,10 @@ int edit_string ( struct edit_string *string, int key ) {
 		/* Delete character */
 		delete_character ( string );
 		break;
+	case CTRL_U:
+		/* Delete to start of line */
+		kill_sol ( string );
+		break;
 	case CTRL_K:
 		/* Delete to end of line */
 		kill_eol ( string );
diff --git a/roms/ipxe/src/hci/mucurses/ansi_screen.c b/roms/ipxe/src/hci/mucurses/ansi_screen.c
index cc342f7ca3040a712edd05300297..d952e5f2aa931caf2c03118e31e2 100644
--- a/roms/ipxe/src/hci/mucurses/ansi_screen.c
+++ b/roms/ipxe/src/hci/mucurses/ansi_screen.c
@@ -12,6 +12,8 @@ static void ansiscr_putc(struct _curses_screen *scr, chtype c) __nonnull;
 unsigned short _COLS = 80;
 unsigned short _LINES = 24;
 
+static unsigned int saved_usage;
+
 static void ansiscr_reset ( struct _curses_screen *scr ) {
 	/* Reset terminal attributes and clear screen */
 	scr->attrs = 0;
@@ -20,6 +22,16 @@ static void ansiscr_reset ( struct _curses_screen *scr ) {
 	printf ( "\033[0m" );
 }
 
+static void ansiscr_init ( struct _curses_screen *scr ) {
+	saved_usage = console_set_usage ( CONSOLE_USAGE_TUI );
+	ansiscr_reset ( scr );
+}
+
+static void ansiscr_exit ( struct _curses_screen *scr ) {
+	ansiscr_reset ( scr );
+	console_set_usage ( saved_usage );
+}
+
 static void ansiscr_movetoyx ( struct _curses_screen *scr,
 			       unsigned int y, unsigned int x ) {
 	if ( ( x != scr->curs_x ) || ( y != scr->curs_y ) ) {
@@ -65,8 +77,8 @@ static bool ansiscr_peek ( struct _curses_screen *scr __unused ) {
 }
 
 SCREEN _ansi_screen = {
-	.init		= ansiscr_reset,
-	.exit		= ansiscr_reset,
+	.init		= ansiscr_init,
+	.exit		= ansiscr_exit,
 	.movetoyx	= ansiscr_movetoyx,
 	.putc		= ansiscr_putc,
 	.getc		= ansiscr_getc,
diff --git a/roms/ipxe/src/hci/mucurses/mucurses.c b/roms/ipxe/src/hci/mucurses/mucurses.c
index 7c1620210d0f5a2f8f3ada06de6a..ab9a6535ffad9e4a46bafb63aa97 100644
--- a/roms/ipxe/src/hci/mucurses/mucurses.c
+++ b/roms/ipxe/src/hci/mucurses/mucurses.c
@@ -1,4 +1,3 @@
-#include <ipxe/console.h>
 #include <curses.h>
 #include "mucurses.h"
 
diff --git a/roms/ipxe/src/hci/mucurses/widgets/editbox.c b/roms/ipxe/src/hci/mucurses/widgets/editbox.c
index 5d2ba56cc9cc7ec93ef95b5d5bbf..630a66e0b91c11b58c60c3c982db 100644
--- a/roms/ipxe/src/hci/mucurses/widgets/editbox.c
+++ b/roms/ipxe/src/hci/mucurses/widgets/editbox.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/hci/readline.c b/roms/ipxe/src/hci/readline.c
index 32793abe5635e655f9c403335b33..d67980b2cbef68534cd0858656dd 100644
--- a/roms/ipxe/src/hci/readline.c
+++ b/roms/ipxe/src/hci/readline.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -21,6 +22,7 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#include <errno.h>
 #include <ipxe/console.h>
 #include <ipxe/keys.h>
 #include <ipxe/editstring.h>
@@ -240,20 +242,25 @@ void history_free ( struct readline_history *history ) {
  * Read line from console (with history)
  *
  * @v prompt		Prompt string
+ * @v prefill		Prefill string, or NULL for no prefill
  * @v history		History buffer, or NULL for no history
  * @ret line		Line read from console (excluding terminating newline)
+ * @ret rc		Return status code
  *
  * The returned line is allocated with malloc(); the caller must
  * eventually call free() to release the storage.
  */
-char * readline_history ( const char *prompt,
-			  struct readline_history *history ) {
+int readline_history ( const char *prompt, const char *prefill,
+		       struct readline_history *history, char **line ) {
 	char buf[READLINE_MAX];
 	struct edit_string string;
 	int key;
 	int move_by;
 	const char *new_string;
-	char *line;
+	int rc;
+
+	/* Avoid returning uninitialised data on error */
+	*line = NULL;
 
 	/* Display prompt, if applicable */
 	if ( prompt )
@@ -264,6 +271,12 @@ char * readline_history ( const char *prompt,
 	init_editstring ( &string, buf, sizeof ( buf ) );
 	buf[0] = '\0';
 
+	/* Prefill string, if applicable */
+	if ( prefill ) {
+		replace_string ( &string, prefill );
+		sync_console ( &string );
+	}
+
 	while ( 1 ) {
 		/* Handle keypress */
 		key = edit_string ( &string, getkey ( 0 ) );
@@ -272,12 +285,11 @@ char * readline_history ( const char *prompt,
 		switch ( key ) {
 		case CR:
 		case LF:
-			line = strdup ( buf );
-			if ( ! line )
-				printf ( "\nOut of memory" );
+			*line = strdup ( buf );
+			rc = ( ( *line ) ? 0 : -ENOMEM );
 			goto done;
 		case CTRL_C:
-			line = NULL;
+			rc = -ECANCELED;
 			goto done;
 		case KEY_UP:
 			move_by = 1;
@@ -303,11 +315,12 @@ char * readline_history ( const char *prompt,
  done:
 	putchar ( '\n' );
 	if ( history ) {
-		if ( line && line[0] )
-			history_append ( history, line );
+		if ( *line && (*line)[0] )
+			history_append ( history, *line );
 		history_cleanup ( history );
 	}
-	return line;
+	assert ( ( rc == 0 ) ^ ( *line == NULL ) );
+	return rc;
 }
 
 /**
@@ -320,5 +333,8 @@ char * readline_history ( const char *prompt,
  * eventually call free() to release the storage.
  */
 char * readline ( const char *prompt ) {
-	return readline_history ( prompt, NULL );
+	char *line;
+
+	readline_history ( prompt, NULL, NULL, &line );
+	return line;
 }
diff --git a/roms/ipxe/src/hci/shell.c b/roms/ipxe/src/hci/shell.c
index e426ba946f8ee807c55d75e5522e..b62086769aa6745e4ff4d07db8da 100644
--- a/roms/ipxe/src/hci/shell.c
+++ b/roms/ipxe/src/hci/shell.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -85,7 +86,7 @@ int shell ( void ) {
 
 	/* Read and execute commands */
 	do {
-		line = readline_history ( shell_prompt, &history );
+		readline_history ( shell_prompt, NULL, &history, &line );
 		if ( line ) {
 			rc = system ( line );
 			free ( line );
diff --git a/roms/ipxe/src/hci/tui/login_ui.c b/roms/ipxe/src/hci/tui/login_ui.c
index 04aabfa8c75a6447cabd78f47223..52ab0e3603a94f243c2f11af9e10 100644
--- a/roms/ipxe/src/hci/tui/login_ui.c
+++ b/roms/ipxe/src/hci/tui/login_ui.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -32,11 +33,11 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #include <ipxe/editbox.h>
 #include <ipxe/keys.h>
 #include <ipxe/login_ui.h>
+#include <config/colour.h>
 
 /* Colour pairs */
 #define CPAIR_NORMAL		1
-#define CPAIR_LABEL		2
-#define CPAIR_EDITBOX		3
+#define CPAIR_EDIT		2
 
 /* Screen layout */
 #define USERNAME_LABEL_ROW	8
@@ -65,9 +66,8 @@ int login_ui ( void ) {
 	/* Initialise UI */
 	initscr();
 	start_color();
-	init_pair ( CPAIR_NORMAL, COLOR_WHITE, COLOR_BLACK );
-	init_pair ( CPAIR_LABEL, COLOR_WHITE, COLOR_BLACK );
-	init_pair ( CPAIR_EDITBOX, COLOR_WHITE, COLOR_BLUE );
+	init_pair ( CPAIR_NORMAL, COLOR_NORMAL_FG, COLOR_NORMAL_BG );
+	init_pair ( CPAIR_EDIT, COLOR_EDIT_FG, COLOR_EDIT_BG );
 	init_editbox ( &username_box, username, sizeof ( username ), NULL,
 		       USERNAME_ROW, EDITBOX_COL, EDITBOX_WIDTH, 0 );
 	init_editbox ( &password_box, password, sizeof ( password ), NULL,
@@ -75,11 +75,13 @@ int login_ui ( void ) {
 		       EDITBOX_STARS );
 
 	/* Draw initial UI */
+	color_set ( CPAIR_NORMAL, NULL );
 	erase();
-	color_set ( CPAIR_LABEL, NULL );
+	attron ( A_BOLD );
 	mvprintw ( USERNAME_LABEL_ROW, LABEL_COL, "Username:" );
 	mvprintw ( PASSWORD_LABEL_ROW, LABEL_COL, "Password:" );
-	color_set ( CPAIR_EDITBOX, NULL );
+	attroff ( A_BOLD );
+	color_set ( CPAIR_EDIT, NULL );
 	draw_editbox ( &username_box );
 	draw_editbox ( &password_box );
 
